diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_whois.c ircd-hybrid-6.0/src/m_whois.c
--- ircd-hybrid-6.0.orig/src/m_whois.c	Sun Jun 10 11:44:05 2001
+++ ircd-hybrid-6.0/src/m_whois.c	Sat Jun  9 23:46:03 2001
@@ -34,6 +34,7 @@
 #include "send.h"
 #include "list.h"
 #include "irc_string.h"
+#include "s_conf.h"
 
 #include <string.h>
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Sun Jun 10 11:44:05 2001
+++ ircd-hybrid-6.0/src/s_user.c	Sun Jun 10 01:12:10 2001
@@ -2073,6 +2075,8 @@
               return 0;
             }
         }
+      else if (IsServer(sptr))
+	ircophack = 1; /* Remote servers are trusted to set sane umodes. Illicit servers must not be allowed to attach */
       else if (IsServer(cptr))
         sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
 			       "%s issuing MODE for User %s From %s!%s",
@@ -2197,13 +2201,15 @@
 		  }
 	      }
 	    break;
-	    /* This needs no magic. -- asuffield
-	      case 'e' :
-	      if(!IsServer(cptr))
-	      break;
-	      
-	      SetIdentifiedNick(sptr);
-	      break; */
+	  case 'e' :
+	    if(IsServer(cptr))
+	      {
+		if (what==MODE_ADD)
+		  SetBit(acptr->umodes,UMODE_IDENTIFIED);
+		else
+		  ClearBit(acptr->umodes,UMODE_IDENTIFIED);
+	      }
+	    break;
 
 	    /* we may not get these,
 	     * but they shouldnt be in default
@@ -2234,6 +2240,7 @@
 
   /* Find which ones shouldn't have been set, and unset them (and warn) */
   AndNotUmodes(bad_umodes, acptr->umodes, acptr->allowed_umodes);
+  ClearBit(bad_umodes, UMODE_IDENTIFIED); /* Always allow this one, it will never be in allowed_umodes and can't get set by a non-server */
   if (AnyBits(bad_umodes))
     {
       AndUmodes(acptr->umodes, acptr->umodes, acptr->allowed_umodes);
